import es, playerlib, cfglib, gamethread, os, popuplib, random, services

config = cfglib.AddonCFG(es.getAddonPath("alien") + "/alien.cfg")
config.text("**************************")
config.text("   Alien Invasion Options ")
config.text("**************************")
alien_health   = config.cvar("alien_health",   150, "Alien's Health")
alien_speed   = config.cvar("alien_speed",   1.5, "Aliens's Speed")
alien_max   = config.cvar("alien_max",   6, "Amount of t's")
alien_stealth   = config.cvar("alien_stealth",   0, "The Visibility for Aliens")
fbi_health   = config.cvar("fbi_health",   100, "FBI Health")
fbi_speed   = config.cvar("fbi_speed",   1, "FBI Speed")
config.text("\n")
config.text("**************************")
config.text("          Regen           ")
config.text("**************************")
regen_time   = config.cvar("regen_time",   5, "How many seconds till the regen after been hurt")
regen_add   = config.cvar("regen_add",   5, "How often Is added on while regen")
regen_amount   = config.cvar("regen_amount",   5, "Amount goes up by")
config.text("\n")
config.text("**************************")
config.text("Radar and Shadows Enforcer")
config.text("**************************")
variable_checker   = config.cvar("variable_checker",   60, "Checks if they have change <In Seconds>")
radar_check   = config.cvar("radar_check",   1, "Checks if radar is on")
shadow_check   = config.cvar("shadow_check",   1, "Checks if r_shadows is on")
config.text("\n")
config.text("**************************")
config.text("   Downloads and Models   ")
config.text("**************************")
fbimodel_folder   = str(config.cvar("fbimodel_folder",   'models/player/ics/ct_gign_fbi', "Ct model path used for downloads"))
alienmodel_folder   = str(config.cvar("aliemodel_folder",   'models/player/slow/predator_camouflaged', "T's Model path used for downloads"))
fbi_model   = str(config.cvar("fbi_model",   'models/player/ics/ct_gign_fbi/ct_gign.mdl', "FBI Model"))
alien_model   = str(config.cvar("alien_model",   'models/player/slow/predator_camouflaged/predator_camouflaged.mdl', "Alien Model"))
config.text("\n")
config.text("********************")
config.text("     Dissolver      ")
config.text("********************")
dissolve_alienonly = config.cvar("dissolve_alienonly",      1, "Makes it so only aliens Bodies Dissolve")
dissolve_deathtype = config.cvar("dissolve_deathtype",      2, "Death Type: 1 = no dissovle, 2 =  Energy Effect ,3 = Heavy Electrical Effect, 4 = Light Electrical  Effect,5 = Core Effect,6 = Random")
dissolve_command = config.cvar("dissolve_command",      '!dissolve', "What Admins type to Bring Admin menu up")
dissolve_delay = config.cvar("dissolve_delay",      2, "How long before the body dissolves or is removed")

config.write()

dict_players = {}

# ======================#
#               PUBLIC
# ======================#
info = es.AddonInfo()
info.name     = "Alien Invasion"
info.version  = "0.4"
info.url      = "None"
info.basename = "sic_alien"
info.author   = "sicman_adrian"
es.ServerVar('sic_alien', info.version, info.name).makepublic()

# ======================#
#  MODELS&MATERIALS
# ======================#
# Thanks to bonbon for all the download ables help
model_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + fbimodel_folder
model_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + alienmodel_folder
material_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + fbimodel_folder
material_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + alienmodel_folder

weapon_ammo_dict = {'weapon_m4a1':90,'weapon_ak47':90,'weapon_awp':30,'weapon_scout':90,'weapon_sg552':90, 'weapon_galil':90,'weapon_famas':90,'weapon_sg550':90,'weapon_aug':90,'weapon_m249':200,'weapon_g3sg1':90, 'weapon_ump45':100,'weapon_mp5navy':120,'weapon_m3':32,'weapon_xm1014':32,'weapon_tmp':120,'weapon_mac10':120, 'weapon_p90':100,'weapon_usp':100,'weapon_glock':100,'weapon_deagle':35,'weapon_p228':52,'weapon_elite':120,
'weapon_fiveseven':100}

def load():
    config.execute()
    es.doblock('corelib/noisy_on')
    downloads()
    deathtypemenu = popuplib.create('deathtypemenu')
    deathtypemenu.addline('Dissolver Options')
    deathtypemenu.addline('-----------------------')
    deathtypemenu.addline('->1. No Dissovle')
    deathtypemenu.addline('->2. Energy Effect')
    deathtypemenu.addline('->3. Heavy Electrical Effect')
    deathtypemenu.addline('->4. Light Electrical')
    deathtypemenu.addline('->5. Core Effect')
    deathtypemenu.addline('->6. Random')
    deathtypemenu.addline('->0. Exit')
    deathtypemenu.addline('------------------------')
    deathtypemenu.menuselect = deathtypemenu_menuselect
    setup_auth()
    if not es.exists('saycommand', dissolve_command):
        es.regsaycmd(dissolve_command, 'dissolver/sendpopup')

def unload():
    es.doblock('corelib/noisy_off')
    if es.exists('saycommand', dissolve_command):
        es.unregsaycmd(dissolve_command)

def es_map_start(ev):
    downloads()

def downloads():
    for dlfile in os.listdir(model_folder1):
        es.stringtable('downloadables', model_folder1 + dlfile)
    for dlfile in os.listdir(model_folder2):
        es.stringtable('downloadables', model_folder2 + dlfile)
    for dlfile in os.listdir(material_folder1):
        es.stringtable('downloadables', material_folder1 + dlfile)
    for dlfile in os.listdir(material_folder2):
        es.stringtable('downloadables', material_folder2 + dlfile)

def deathtypemenu_menuselect (userid, choice, popupid):
    global dissolve_deathtype
    if choice in [1,2,3,4,5,6]:
        dissolve_deathtype = choice
        popuplib.send('deathtypemenu', userid)

def player_connect(ev):
    userid = ev['userid']
    if userid not in dict_players:
        dict_players[userid] = {'kick':0}

def player_spawn(ev):
    userid = ev['userid']
    player = playerlib.getPlayer(userid)
    if ev['es_userteam'] == '2':
        player.set('model', alien_model)
        player.set('speed', alien_speed)
        player.set('color', (255, 255, 255, alien_stealth))
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', alien_health)
        es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
        es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)
        gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_knife'%userid)
        gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)
    elif ev['es_userteam'] == '3':
          player.set('model', fbi_model)
          player.set('speed', fbi_speed)
          es.setplayerprop(userid, 'CBasePlayer.m_iHealth', fbi_health)
          gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)
    if radar_check:
        es.queryclientvar(userid, 'cl_radaralpha')
    if shadow_check:
        es.queryclientvar(userid, 'r_shadows')
    if dict_players[userid]['kick'] == 3:
        es.server.queuecmd('kickid %s You were Kick cause you did not Change cl_radaraplha or r_shadows' % userid)

def player_death(ev):
    gamethread.cancelDelayed('regen %s'%ev['userid'])
    userid = ev['userid']
    if dissolve_deathtype == 6:
        mode = random.randint(1,5)
    else:
        mode = dissolve_deathtype
    if dissolve_alienonly:
        if ev['userteam'] == 2:
            dissolve(userid, mode)
    else:
        dissolve(userid, mode)

def weapon_reload(event_var):
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    weapon = myPlayer.attributes['weapon']
    if weapon in weapon_ammo_dict:
        myPlayer.set('ammo',(weapon,weapon_ammo_dict[weapon]))

def item_pickup(ev):
    userid = ev['userid']
    if ev['es_userteam'] == '2':
        if ev['item'] != 'knife':
            es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
            es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
            es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_knife'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)

def weapon_fire(ev):
    userid = ev['userid']
    myPlayer = playerlib.getPlayer(userid)
    weapon = myPlayer.attributes['weapon']
    if ev['es_userteam'] == '2':
        if ev['es_userweapon'] != 'weapon_knife':
            es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
            es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
            es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_knife'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)

def round_end(ev):
    userid = ev['userid']
    teams()
    gamethread.cancelDelayed('checker %s'%userid) 
    if radar_check:
        es.queryclientvar(userid, 'cl_radaralpha')
    if shadow_check:
        es.queryclientvar(userid, 'r_shadows')
    gamethread.delayedname(variable_checker, 'checker %s'%userid, checker, userid)

def checker(userid):
    gamethread.cancelDelayed('checker %s'%userid) 
    gamethread.delayedname(variable_checker, 'checker %s'%userid, checker, userid)
    if radar_check:
        es.queryclientvar(userid, 'cl_radaralpha')
    if shadow_check:
        es.queryclientvar(userid, 'r_shadows')

def teams():
    t = es.getplayercount('2')
    if t > alien_max:
        userid = random.choice(playerlib.getUseridList('#t'))
        es.server.queuecmd('est_team %s 3'% userid)
        es.tell(userid, '#multi','#greenYou have been moved to ct')
        teams()


def es_player_variable(ev):
    userid = ev['userid']
    if ev['status'] == 'success':
        if ev['variable'] == 'cl_radaralpha':
            if int(ev['value']) != 0:
                es.changeteam(ev['userid'], 1)
                es.tell(ev['userid'], '#multi', '#greenYou must type #lightgreencl_radaralpha 0#green in your console if you want to play, If you don\'t you will be kicked!')
                dict_players[userid]['kick'] += 1
        if ev['variable'] == 'r_shadows':
            if int(ev['value']) != 0:
                es.changeteam(ev['userid'], 1)
                es.tell(ev['userid'], '#multi', '#greenYou must type #lightgreen r_shadows 0#green in your console if you want to play, If you don\'t you will be kicked!')
                dict_players[userid]['kick'] += 1


def player_disconnect(ev):
    userid = ev['userid']
    for delay in ['regen','checker']:
        gamethread.cancelDelayed(delay + ev['userid'])
    if es.exists('userid', userid):
        del dict_players[userid]


def player_hurt(ev):
    userid = ev['userid']
    if ev['es_userteam'] == '2':
        gamethread.cancelDelayed('regen %s'%userid) 
        gamethread.delayedname(regen_time, 'regen %s'%userid, regen, userid) 

def regen(userid):
    health = es.getplayerprop(userid, 'CBasePlayer.m_iHealth')
    if health+regen_amount <=  alien_health:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health+regen_amount)
        gamethread.delayedname(regen_add, 'regen %s'%userid, regen, userid)
    else:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', alien_health)

def dissolve(userid, mode):
    if mode == 1:
        es.delayed(dissolve_delay, 'est_setentname %s cs_ragdoll_%s'%(findRadgollByUserid(userid), userid))
        es.delayed(dissolve_delay, 'es_xfire %s cs_ragdoll_%s kill' % (userid, userid))
    else:
        es.delayed(dissolve_delay, 'es_xgive %s env_entity_dissolver' % userid)
        es.delayed(dissolve_delay, 'est_setentname %s cs_ragdoll_%s'%(findRadgollByUserid(userid), userid))
        es.delayed(dissolve_delay, 'es_xfire %s env_entity_dissolver AddOutput "target cs_ragdoll_%s"' % (userid, userid))
        es.delayed(dissolve_delay, 'es_xfire %s env_entity_dissolver AddOutput "magnitude 1"' % userid)
        es.delayed(dissolve_delay, 'es_xfire %s env_entity_dissolver AddOutput "dissolvetype %s"' % (userid,mode-2))
        es.delayed(dissolve_delay, 'es_xfire %s env_entity_dissolver Dissolve' % userid)

def findRagdollByUserid(userid):
   handle = es.getplayerhandle(userid)
   for index in es.createentitylist('cs_ragdoll'):
      if es.getindexprop(index, 'CCSRagdoll.m_hPlayer') == handle:
         return index
   return 0

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('alien_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'alien_admin')
    else:
        isAuthed = lambda x: False

def sendpopup():
    userid = es.getcmduserid()
    if isAuthed(userid):
        popuplib.send('deathtypemenu', userid)
    else:
        es.tell(userid, '#multi','#greenYou are not authorised to run the command admin!') 